Package com.smartgwt.client.core

# Class DataClass

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass

All Implemented Interfaces:
  `HasHandlers`

Direct Known Subclasses:
  `AceCompletionResult`, `AcePosition`, `AIFieldRequest`, `AIMessage`, `AIProgressMessage`, `AnimateShowEffect`, `BrowserWindowSettings`, `CreateDashboardComponentDataQuestionStep`, `CreateDashboardComponentDataQuestionStepResult`, `CreateDashboardDataQuestionStep`, `CreateScreenSettings`, `Criteria`, `CriteriaOutputSettings`, `DataContext`, `DataContextBinding`, `DataQuestion`, `DataQuestionSettings`, `DataQuestionStep`, `DataQuestionStepResult`, `DebugOverflowSettings`, `DecisionBranch`, `DiscoverTreeSettings`, `DrawnValue`, `DrawShapeCommand`, `DSLoadSettings`, `EventStreamData`, `EventStreamEvent`, `ExecuteQueryDataQuestionStepResult`, `FacetValueMap`, `FileSpec`, `FilterViaAISettings`, `FixDashboardComponentDataQuestionStep`, `FixDashboardComponentDataQuestionStepResult`, `FormItemEventInfo`, `FormItemIcon`, `Gradient`, `GroupSpecifier`, `HeaderSpan`, `HiliteViaAISettings`, `ImgHTMLProperties`, `KeyIdentifier`, `ListProperties`, `LoadProjectSettings`, `LoadScreenSettings`, `MakeQueryDataQuestionStepResult`, `MetricSettings`, `MockDSExportSettings`, `MultiWindowSettings`, `NavigationBarViewState`, `NotifyAction`, `NotifySettings`, `OperationBinding`, `PortalPosition`, `PrintProperties`, `PromiseOutcome`, `PropertyValue`, `QualityIndicatedLocator`, `RefDataClass`, `RelationPath`, `RelativeDate`, `SavedSearches`, `SCStatefulImgConfig`, `SeleneseSettings`, `SeleniumCommand`, `SerializationContext`, `SerializationSettings`, `Shadow`, `SortSpecifier`, `StretchItem`, `StyleGroup`, `StyleSetting`, `SummarizeValueExample`, `SystemDoneConfig`, `UserFormula`, `UserSummary`, `ValidateDashboardComponentDataQuestionStep`, `ValidateDashboardComponentDataQuestionStepResult`, `Validator`, `XmlNamespaces`

public class DataClass extends JsObject implements HasHandlers

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected boolean`
  `factoryCreated`
  `protected Map<String,Object>`
  `factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DataClass()`
  `DataClass(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `applyFactoryProperties()`
  `protected final <H extends EventHandler>
  HandlerRegistration`
  `doAddHandler(H handler, GwtEvent.Type<H> type)`
  `void`
  `fireEvent(GwtEvent<?> event)`
  `String`
  `getAttribute(String property)`
  Returns attribute value as a String
  `Boolean`
  `getAttributeAsBoolean(String property)`
  Returns attribute value set as a Boolean.
  `Boolean`
  `getAttributeAsBoolean(String property, boolean allowNull)`
  Returns attribute value set as a Boolean.
  `Date`
  `getAttributeAsDate(String property)`
  Returns attribute value as a Date.
  `Double`
  `getAttributeAsDouble(String property)`
  Returns attribute as a Double.
  `double[]`
  `getAttributeAsDoubleArray(String property)`
  Returns attribute as a double array.
  `Element`
  `getAttributeAsElement(String property)`
  Get the attribute value as an Element.
  `Float`
  `getAttributeAsFloat(String property)`
  Returns attribute value as a Float.
  `Integer`
  `getAttributeAsInt(String property)`
  Returns attribute value as an Integer.
  `int[]`
  `getAttributeAsIntArray(String property)`
  Returns attribute as an int array.
  `JavaScriptObject`
  `getAttributeAsJavaScriptObject(String property)`
  Returns attribute value as a JavaScript Object.
  `Long`
  `getAttributeAsLong(String property)`
  Returns attribute as a Long.
  `Map`
  `getAttributeAsMap(String property)`
  Returns attribute value as a Map.
  `Object`
  `getAttributeAsObject(String property)`
  Returns attribute value as a Java Object.
  `Record`
  `getAttributeAsRecord(String property)`
  Get the attribute value as a Record.
  `String`
  `getAttributeAsString(String property)`
  Returns attribute value as a String.
  `String[]`
  `getAttributeAsStringArray(String property)`
  Returns attribute as a String array.
  `String[]`
  `getAttributes()`
  `int`
  `getHandlerCount(GwtEvent.Type<?> type)`
  `boolean`
  `isFactoryCreated()`
  `DataClass`
  `setAttribute(String property, boolean value)`
  Set attribute value to a boolean.
  `DataClass`
  `setAttribute(String property, double value)`
  Set attribute value to a double.
  `DataClass`
  `setAttribute(String property, double[] value)`
  Set attribute value to a double array.
  `DataClass`
  `setAttribute(String property, int value)`
  Set attribute value to an int.
  `DataClass`
  `setAttribute(String property, int[] value)`
  Set attribute value to an int array.
  `DataClass`
  `setAttribute(String property, long value)`
  Set attribute value to a long.
  `DataClass`
  `setAttribute(String property, JavaScriptObject value)`
  Set attribute value to a JavaScriptObject.
  `DataClass`
  `setAttribute(String property, BaseClass value)`
  Set attribute value to a BaseClass.
  `DataClass`
  `setAttribute(String property, BaseClass[] value)`
  Set attribute value to a BaseClass array.
  `DataClass`
  `setAttribute(String property, DataClass value)`
  Set attribute value to a DataClass.
  `DataClass`
  `setAttribute(String property, DataClass[] value)`
  Set attribute value to a DataClass array.
  `DataClass`
  `setAttribute(String property, ValueEnum value)`
  Set attribute value to a ValueEnum.
  `DataClass`
  `setAttribute(String property, ValueEnum[] value)`
  Set attribute value to a ValueEnum array.
  `DataClass`
  `setAttribute(String property, BaseWidget[] value)`
  Set attribute value to a BaseWidget array.
  `DataClass`
  `setAttribute(String property, Boolean value)`
  Set attribute value to a Boolean.
  `DataClass`
  `setAttribute(String property, Double value)`
  Set attribute value to a Double.
  `DataClass`
  `setAttribute(String property, Float value)`
  Set attribute value to a Float.
  `DataClass`
  `setAttribute(String property, Integer value)`
  Set attribute value to an Integer.
  `DataClass`
  `setAttribute(String property, Integer[] value)`
  Set attribute value to an Integer array.
  `DataClass`
  `setAttribute(String property, Object value)`
  Set the attribute value to an Object.
  `DataClass`
  `setAttribute(String property, String value)`
  Set attribute value to a String
  `DataClass`
  `setAttribute(String property, String[] value)`
  Set attribute value to a String array.
  `DataClass`
  `setAttribute(String property, Date value)`
  Set attribute value to a Date.
  `DataClass`
  `setAttribute(String property, Map value)`
  Set attribute value to a Map.
  `DataClass`
  `setAttributeAsJavaObject(String property, Object value)`
  Set the attribute value to an Object.
  `void`
  `setFactoryCreated(boolean createdByBeanFactory)`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### factoryProperties

    protected Map<String,Object> factoryProperties

  - ### factoryCreated

    protected boolean factoryCreated

- ## Constructor Details

  - ### DataClass

    public DataClass()

  - ### DataClass

    public DataClass(JavaScriptObject jsObj)

- ## Method Details

  - ### applyFactoryProperties

    public void applyFactoryProperties()

  - ### setFactoryCreated

    public void setFactoryCreated(boolean createdByBeanFactory)

  - ### isFactoryCreated

    public boolean isFactoryCreated()

  - ### setAttribute

    public DataClass setAttribute(String property, String value)
    Set attribute value to a String
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### getAttribute

    public String getAttribute(String property)
    Returns attribute value as a String
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsString

    public String getAttributeAsString(String property)
    Returns attribute value as a String.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsInt

    public Integer getAttributeAsInt(String property)
    Returns attribute value as an Integer. Applies to values stored as a JavaScript number on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsBoolean

    public Boolean getAttributeAsBoolean(String property)
    Returns attribute value set as a Boolean. For convenience in checking boolean properties, `getAttributeAsBoolean` will return Boolean `false` if the attribute value is `null` or not a Boolean. Use the two parameter variant of this API `getAttributeAsBoolean(String, boolean)` if you want `null` returned for `null` attribute values.
    Parameters:
      `property` - the property name
    Returns:
      the property value

  - ### getAttributeAsBoolean

    public Boolean getAttributeAsBoolean(String property, boolean allowNull)
    Returns attribute value set as a Boolean. If the attribute value is `null` or not a Boolean, the return value depends upon `allowNull`. If `allowNull` is true, `null` will be returned; otherwise Boolean `false` will be returned. For a simpler approach that never returns `null`, use the one parameter variant of this API `getAttributeAsBoolean(String)`.
    Parameters:
      `property` - the property name
      `allowNull` - whether to allow null
    Returns:
      the property value

  - ### getAttributeAsDouble

    public Double getAttributeAsDouble(String property)
    Returns attribute as a Double. Applies to values stored as a JavaScript Number on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsLong

    public Long getAttributeAsLong(String property)
    Returns attribute as a Long. Applies to values stored as a JavaScript Number on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsDoubleArray

    public double[] getAttributeAsDoubleArray(String property)
    Returns attribute as a double array. Applies to values stored as a JavaScript Array of Numbers on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### setAttribute

    public DataClass setAttribute(String property, DataClass[] value)
    Set attribute value to a DataClass array. Value will be stored as a JavaScript Array of the underlying JavaScript objects for each entry.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, BaseClass[] value)
    Set attribute value to a BaseClass array. Value will be stored as a JavaScript Array of the underlying JavaScript objects for each entry.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, BaseWidget[] value)
    Set attribute value to a BaseWidget array. Value will be stored as a JavaScript Array of the underlying JavaScript objects for each entry.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### getAttributeAsIntArray

    public int[] getAttributeAsIntArray(String property)
    Returns attribute as an int array. Applies to values stored as a JavaScript Array of Numbers on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### setAttribute

    public DataClass setAttribute(String property, String[] value)
    Set attribute value to a String array. Value will be stored as a JavaScript Array of Strings on the underlying data object.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### getAttributeAsStringArray

    public String[] getAttributeAsStringArray(String property)
    Returns attribute as a String array. Applies to values stored as a JavaScript Array of Strings on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### setAttribute

    public DataClass setAttribute(String property, DataClass value)
    Set attribute value to a DataClass. Value will be stored as the underlying JavaScript object for the DataClass instance passed in.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, BaseClass value)
    Set attribute value to a BaseClass. Value will be stored as the underlying JavaScript object for the BaseClass instance passed in.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, JavaScriptObject value)
    Set attribute value to a JavaScriptObject.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Date value)
    Set attribute value to a Date. Value will be stored as a JavaScript Date on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Map value)
    Set attribute value to a Map. Value will be stored as a JavaScript Object on the underlying data object, with property/value pairs matching the keys/values specified on the Map. Note that this is a recursive conversion - each value will also be converted to the equivalent JavaScript type where appropriate.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, ValueEnum[] value)
    Set attribute value to a ValueEnum array. Value will be stored as a JavaScript Array containing the each Enum value.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, ValueEnum value)
    Set attribute value to a ValueEnum. The value of the ValueEnum will be stored on the underlying data object.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Object value)
    Set the attribute value to an Object.

    The values provided as attributes are generally expected to contain valid values for a field of a DataBoundComponent. Therefore this method converts the value passed in to an equivalent object in JavaScript before storing on underlying data object.
    Developers can use `setAttributeAsJavaObject(String, Object)` to store Java objects without converting to JavaScript.

    Conversions that occur include:

    - Numeric data types will be represented as JavaScript Number
    - Dates (and subclasses) will be stored as JavaScript Date
    - Java Arrays will be stored as JavaScript Array, with members converted to the equivalent JavaScript type where appropriate
    - Java Collections (including List, Set) will be stored as JavaScript Array, with members converted to the equivalent JavaScript object (recursively) where appropriate
    - Maps are stored as JavaScript Objects with each key mapped to a property on the object. Property values are converted to the equivalent JavaScript object (recursively) where appropriate
    Other Java Objects, including POJOs are stored on the underlying data object unconverted. Developers can retrieve such values via `getAttributeAsObject(String)`.
    Parameters:
      `property` - the attribute name
      `value` - the attribute value.
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttributeAsJavaObject

    public DataClass setAttributeAsJavaObject(String property, Object value)
    Set the attribute value to an Object.

    Unlike `setAttribute(String, Object)`, this method will store the value passed in as-is rather than converting to an equivalent object in JavaScript.

    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, boolean value)
    Set attribute value to a boolean.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Boolean value)
    Set attribute value to a Boolean.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, int value)
    Set attribute value to an int. Value will be stored as a JavaScript Number on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Integer value)
    Set attribute value to an Integer. Value will be stored as a JavaScript Number on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, long value)
    Set attribute value to a long. Value will be stored as a JavaScript Number on the underlying data object.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Float value)
    Set attribute value to a Float. Value will be stored as a JavaScript Number on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, double value)
    Set attribute value to a double. Value will be stored as a JavaScript Number on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Double value)
    Set attribute value to a Double. Value will be stored as a JavaScript Number on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, int[] value)
    Set attribute value to an int array. Value will be stored as a JavaScript Array of Numbers on the underlying data object.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, Integer[] value)
    Set attribute value to an Integer array. Value will be stored as a JavaScript Array of Numbers on the underlying data object.
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### setAttribute

    public DataClass setAttribute(String property, double[] value)
    Set attribute value to a double array. Value will be stored as a JavaScript Array of Numbers on the underlying data object
    Parameters:
      `property` -
      `value` -
    Returns:
      `DataClass` instance, for chaining setter calls

  - ### getAttributeAsFloat

    public Float getAttributeAsFloat(String property)
    Returns attribute value as a Float. Applies to values stored as a JavaScript number on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsDate

    public Date getAttributeAsDate(String property)
    Returns attribute value as a Date. Applies to values stored as a JavaScript Date on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsObject

    public Object getAttributeAsObject(String property)
    Returns attribute value as a Java Object.

    If the attribute has been set as a Java Object (typically via a call to `setAttributeAsJavaObject(String, Object)`) it will be returned as is.

    Values specified as JavaScript types will be converted to the equivalent Java type if possible.

    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsMap

    public Map getAttributeAsMap(String property)
    Returns attribute value as a Map. Applies to values stored as a JavaScript Object on the underlying data object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributeAsRecord

    public Record getAttributeAsRecord(String property)
    Get the attribute value as a Record.
    Parameters:
      `property` - the property name
    Returns:
      the record value

  - ### getAttributeAsElement

    public Element getAttributeAsElement(String property)
    Get the attribute value as an Element.
    Parameters:
      `property` - the property name
    Returns:
      the element

  - ### getAttributeAsJavaScriptObject

    public JavaScriptObject getAttributeAsJavaScriptObject(String property)
    Returns attribute value as a JavaScript Object.
    Parameters:
      `property` -
    Returns:

  - ### getAttributes

    public String[] getAttributes()

  - ### fireEvent

    public void fireEvent(GwtEvent<?> event)
    Specified by:
      `fireEvent` in interface `HasHandlers`

  - ### doAddHandler

    protected final <H extends EventHandler> HandlerRegistration doAddHandler(H handler, GwtEvent.Type<H> type)

  - ### getHandlerCount

    public int getHandlerCount(GwtEvent.Type<?> type)